﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace FluentInterfaces {
	class Program {
		static void Main(string[] args) {
			Console.WriteLine("Red: " + Color.Red.ToARGBString());
			Console.WriteLine("Green: " + Color.Green.ToARGBString());

			Console.WriteLine(Color.Red.MixedWith(Color.Green));

			Console.WriteLine(20.Minutes().Ago());
		}
	}

	public static class ColorHelpers {
		public static Color MixedWith(this Color color1, Color color2) {
			return Color.FromArgb(
				(color1.A + color2.A) / 2,
				Math.Min(255, color1.R + color2.R),
				Math.Min(255, color1.G + color2.G),
				Math.Min(255, color1.B + color2.B));
		}

		public static string ToARGBString(this Color color) {
			return String.Format("ARGB: ({0}/{1}/{2}/{3})", color.A, color.R, color.G, color.B);
		}
	}

	// The methods in this case have to cleverly return different types
	// so that meaningful chaining becomes possible
	public static class TimeHelpers {
		public static TimeSpan Minutes(this int minutes) {
			return TimeSpan.FromMinutes(minutes);
		}

		public static DateTime Ago(this TimeSpan timeSpan) {
			return DateTime.Now.Subtract(timeSpan);
		}
	}
}