﻿using System;
using System.Collections.Generic;
using System.Text;

namespace RubyStyleIterations {
	class Program {
		static void Main(string[] args) {
			5.Times(i => { Console.WriteLine(i); });

			// Einfache Implementation, spezifische Syntax
			44.UpTo(50, i => { Console.WriteLine(i); });

			// Komplexere Implementation, "generischere" Syntax
			33.UpTo(40)(i => { Console.WriteLine(i); });
		}
	}

	public static class Helpers {
		public static void Times(this int times, Action<int> action) {
			for (int i = 0; i < times; i++) {
				action(i);
			}
		}

		public delegate void TakeActionDelegate(Action<int> action);

		public static TakeActionDelegate UpTo(this int startVal, int upTo) {
			return action =>
			{
				for (int i = startVal; i <= upTo; i++)
					action(i);

				// UpTo(startVal, upTo, action);
			};
		}

		public static void UpTo(this int startVal, int upTo, Action<int> action) {
			for (int i = startVal; i <= upTo; i++)
				action(i);
		}
	}
}