﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Linq.Expressions;
using System.Collections;
using System.Xml.Linq;

namespace QBE {
  public partial class Form1 : Form {
    public Form1( ) {
      InitializeComponent( );

      sourceElement = XElement.Load("Customers.xml");
      customerElement = sourceElement.Element("Customer");

      ConfigureCollection( );
    }

    Expression<Func<XElement,bool>> filterExpression;
    XElement sourceElement;
    XElement customerElement;

    void ConfigureCollection( ) {
      grid.DataSource = CreateCollection( );
      statusLabel.Text = filterExpression != null ?
        filterExpression.ToString( ) : "Unfiltered";
    }

    IList CreateCollection( ) {
      var allCustomers = sourceElement.Elements("Customer");
      var filteredCustomers = filterExpression != null ?
        allCustomers.Where(filterExpression.Compile()) : allCustomers;
      var result = from customer in filteredCustomers
                   select new {
                            CustomerId = (string) customer.Element("CustomerID"),
                            CompanyName = (string) customer.Element("CompanyName"),
                            ContactName = (string) customer.Element("ContactName"),
                            ContactTitle = (string) customer.Element("ContactTitle"),
                            Address = (string) customer.Element("Address"),
                            City = (string) customer.Element("City"),
                            PostalCode = (string) customer.Element("PostalCode"),
                            Country = (string) customer.Element("Country"),
                            Phone = (string) customer.Element("Phone"),
                            Fax = (string) customer.Element("Fax")
                          };
      return result.ToList( );
    }

    private void toolStripButton1_Click(object sender, EventArgs e) {
      filterExpression = FilterForm.GetNewFilter(customerElement, filterExpression);
      ConfigureCollection();
    }
  }
}
