﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EmptyAnonymousList {
  class Program {
    static void Main(string[] args) {
      var foo = new {
                  Name = "Pete",
                  Age = 33
                };
      var bar = new {
                  Name = "Harry",
                  Age = 41
                };

      var listoffoo = CreateList(foo);

      // listoffoo.GetType().GetGenericArguments() will show you now that the list 
      // is typed for the (anonymous) type of foo (use foo.GetType().Name to compare
      // the name of the type.

      // We are also able to add bar to the list, because it's actually the same type
      listoffoo.Add(bar);

      // Just to be sure we're not being fooled here, we can't add just any type.
      // The following two will result in a compile time error.
      
//      listoffoo.Add("A string");
//
//      listoffoo.Add(new {
//                  Age = 41,
//                  Name = "Willy"
//                });

    }

    static List<T> CreateList<T>(T instance) {
      return new List<T>(new[] { instance });
    }
  }
}
