﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.IO;

namespace QueryEngine {
  public class LegacyEngine {
    public LegacyEngine(string filename) {
      data = new Dictionary<string, string>( );
      using (StreamReader sr = File.OpenText(filename)) {
        while (!sr.EndOfStream) {
          string line = sr.ReadLine( );
          var match = Regex.Match(line, @"(?<index>.*?):(?<data>.*)");
          if (match.Success)
            data[match.Groups["index"].Value] = match.Groups["data"].Value;
        }
      }
    }

    private Dictionary<string, string> data;

    public string Query(string query) {
      var match = Regex.Match(query, @"get me (?<index>.*)\s*", RegexOptions.IgnoreCase);
      if (match.Success) {
        var index = match.Groups["index"].Value;
        if (data.ContainsKey(index))
          return data[index];
      }
      else 
        throw new InvalidOperationException("The query string wasn't in any known format.");

      return "";
    }
  }
}
